﻿Public Class Form1

    Private WithEvents Ticker As New Timer With {.Interval = 1}

    Private Roll As New Roller()

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Ticker.stop()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DoubleBuffered = True
        TrackBar1.Maximum = 3
        Ticker.Start()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Roll.DrawRoller(e.Graphics, TrackBar1.Value)
    End Sub

    Private Sub Ticker_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Ticker.Tick
        Invalidate(Roll.Rect)
    End Sub

End Class

Public Class Roller

    Private Rand As New Random

    Public Sub New()
        For i = 0 To 3
            Fields(i) = New RollerField
            Fields(i).Rect = New Rectangle(Rect.X, Rect.Y + 50 * i, 50, 50)
            Fields(i).IconIndex = Rand.Next(0, 5)
        Next
    End Sub

    Public Rect As New Rectangle(100, 100, 50, 150)
    Private Sheet As Bitmap = My.Resources.sheet
    Private Fields(3) As RollerField
    Private OffSet As Integer = 1

    Public Sub DrawRoller(ByVal g As Graphics, ByVal speed As Integer)
        g.DrawRectangle(Pens.Black, Rect)
        Dim src As Rectangle
        Dim dest As Rectangle
        For i = 0 To 3
            Select Case i
                Case 0
                    src = New Rectangle((speed - 1) * 50, Fields(i).IconIndex * 50 + 50 - OffSet, 50, OffSet)
                    dest = New Rectangle(Fields(i).Rect.X, Fields(i).Rect.Y, 50, OffSet)
                Case 1, 2
                    src = New Rectangle((speed - 1) * 50, Fields(i).IconIndex * 50, 50, 50)
                    dest = New Rectangle(Fields(i).Rect.X, Fields(i).Rect.Y - 50 + OffSet, 50, 50)
                Case 3
                    src = New Rectangle((speed - 1) * 50, Fields(i).IconIndex * 50, 50, 50 - OffSet)
                    dest = New Rectangle(Fields(i).Rect.X, Fields(i).Rect.Y - 50 + OffSet, 50, 50 - OffSet)

            End Select
            If speed = 0 Then
                src.X = speed * 50
            End If
            g.DrawImage(Sheet, dest, src, GraphicsUnit.Pixel)
        Next
        OffSet += speed * 4
        If OffSet >= 51 Then
            Fields(3).IconIndex = Fields(2).IconIndex
            Fields(2).IconIndex = Fields(1).IconIndex
            Fields(1).IconIndex = Fields(0).IconIndex
            Fields(0).IconIndex = Rand.Next(0, 5)
            OffSet = 1
        End If
    End Sub

End Class

Public Class RollerField

    Public Rect As Rectangle
    Public IconIndex As Integer
    Public BlurIndex As Integer

End Class